<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="流水号" prop="standNo">
        <el-input v-model="formData.standNo" placeholder="请输入流水号" />
      </el-form-item>
      <el-form-item label="名称" prop="standName">
        <el-input v-model="formData.standName" placeholder="请输入名称" />
      </el-form-item>
      <el-form-item label="状态" prop="state">
        <el-select v-model="formData.state" placeholder="请选择状态">
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.EFFECTIVE_STATUS)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
<!--      <el-form-item label="排序" prop="sort">-->
<!--        <el-input v-model="formData.sort" placeholder="请输入排序" />-->
<!--      </el-form-item>-->
    </el-form>
    <!-- 子表的表单 -->
    <el-tabs v-model="subTabsName">
      <el-tab-pane label="设备保养标准耗材" name="maintenanceStandardConsumable">
        <MaintenanceStandardConsumableForm ref="maintenanceStandardConsumableFormRef" :stand-id="formData.id" />
      </el-tab-pane>
      <el-tab-pane label="设备保养标准内容" name="maintenanceStandardItem">
        <MaintenanceStandardItemForm ref="maintenanceStandardItemFormRef" :stand-id="formData.id" />
      </el-tab-pane>
    </el-tabs>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { MaintenanceStandardApi } from '@/api/device/maintenancestandard'
import MaintenanceStandardConsumableForm from './components/MaintenanceStandardConsumableForm.vue'
import MaintenanceStandardItemForm from './components/MaintenanceStandardItemForm.vue'
import {DICT_TYPE, getIntDictOptions} from "@/utils/dict";

/** 设备保养标准 表单 */
defineOptions({ name: 'MaintenanceStandardForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  standNo: undefined,
  standName: undefined,
  state: undefined,
  sort: undefined,
})
const formRules = reactive({
  standNo: [{ required: true, message: '流水号不能为空', trigger: 'blur' }],
  standName: [{ required: true, message: '名称不能为空', trigger: 'blur' }],
  state: [{ required: true, message: '状态不能为空', trigger: 'change' }]
})
const formRef = ref() // 表单 Ref

/** 子表的表单 */
const subTabsName = ref('maintenanceStandardConsumable')
const maintenanceStandardConsumableFormRef = ref()
const maintenanceStandardItemFormRef = ref()

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await MaintenanceStandardApi.getMaintenanceStandard(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 校验子表单
  try {
    await maintenanceStandardConsumableFormRef.value.validate()
  } catch (e) {
    subTabsName.value = 'maintenanceStandardConsumable'
    return
  }
  try {
    await maintenanceStandardItemFormRef.value.validate()
  } catch (e) {
    subTabsName.value = 'maintenanceStandardItem'
    return
  }
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as MaintenanceStandard
    // 拼接子表的数据
    data.maintenanceStandardConsumables = maintenanceStandardConsumableFormRef.value.getData()
    data.maintenanceStandardItems = maintenanceStandardItemFormRef.value.getData()
    if (formType.value === 'create') {
      await MaintenanceStandardApi.createMaintenanceStandard(data)
      message.success(t('common.createSuccess'))
    } else {
      await MaintenanceStandardApi.updateMaintenanceStandard(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    standNo: undefined,
    standName: undefined,
    state: undefined,
    sort: undefined,
  }
  formRef.value?.resetFields()
}
</script>
